"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var webtyped_common_1 = require("@guimabdo/webtyped-common");
var $ = require("jquery");
var any$ = $;
any$.webtyped = new webtyped_common_1.WebTypedEventEmitter();
var WebTypedClient = /** @class */ (function () {
    function WebTypedClient(baseUrl, api) {
        if (baseUrl === void 0) { baseUrl = WebTypedClient.baseUrl; }
        if (api === void 0) { api = WebTypedClient.api; }
        this.baseUrl = baseUrl;
        this.api = api;
        this.baseUrl = this.baseUrl || "/";
        this.api = this.api || "";
    }
    WebTypedClient.prototype.invokeGet = function (info, action, search) {
        return this.invoke(info, action, 'get', null, search);
    };
    WebTypedClient.prototype.invokePatch = function (info, action, body, search) {
        return this.invoke(info, action, 'patch', body, search);
    };
    WebTypedClient.prototype.invokePost = function (info, action, body, search) {
        return this.invoke(info, action, 'post', body, search);
    };
    WebTypedClient.prototype.invokePut = function (info, action, body, search) {
        return this.invoke(info, action, 'put', body, search);
    };
    WebTypedClient.prototype.invokeDelete = function (info, action, search) {
        return this.invoke(info, action, 'delete', null, search);
    };
    WebTypedClient.prototype.invoke = function (info, action, httpMethod, body, search) {
        var url = webtyped_common_1.WebTypedUtils.resolveActionUrl(this.baseUrl, this.api, action);
        if (search) {
            if (url.indexOf('?') < 0) {
                url += '?';
            }
            else {
                url += '&';
            }
            url += webtyped_common_1.WebTypedUtils.resolveQueryParametersString(search); //$.param(search);
        }
        var jqXhr = $.ajax({
            url: url,
            cache: false,
            dataType: 'json',
            contentType: 'application/json',
            data: body ? JSON.stringify(body) : undefined,
            method: httpMethod,
        });
        jqXhr.done(function (result) {
            var anyWebTyped = webtyped_common_1.WebTypedEventEmitter;
            info.result = result;
            anyWebTyped.single.emit(info);
        });
        return jqXhr;
    };
    //Global setting
    WebTypedClient.baseUrl = null;
    WebTypedClient.api = null;
    return WebTypedClient;
}());
exports.WebTypedClient = WebTypedClient;
